ON_PointCloud Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_pointcloud.h>`

Inheritance diagram for ON_PointCloud:

## Public Member Functions

| ON_PointCloud ()
| ON_PointCloud (int)
| ON_PointCloud (const ON_PointCloud &)
| ~ON_PointCloud ()
ON_PointCloud & | operator= (const ON_PointCloud &)
ON_3dPoint & | operator[] (int)
const ON_3dPoint & | operator[] (int) const
ON_3dPoint | Point (ON_COMPONENT_INDEX ci) const
void | Destroy ()
void | EmergencyDestroy ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | Transform (const ON_Xform &)
bool | IsDeformable () const
bool | MakeDeformable ()
ON_BOOL32 | SwapCoordinates (int, int)
bool | GetClosestPoint (ON_3dPoint P, int *closest_point_index, double maximum_distance=0.0) const
int | PointCount () const
void | AppendPoint (const ON_3dPoint &)
void | InvalidateBoundingBox ()
void | SetOrdered (bool bOrdered)
bool | IsOrdered () const
bool | HasPlane () const
void | SetPlane (const ON_Plane &)
const ON_Plane & | Plane ()
double | Height (int)
bool | HasPointNormals () const
bool | HasPointColors () const
int | HiddenPointCount () const
void | DestroyHiddenPointArray ()
const bool * | HiddenPointArray () const
void | SetHiddenPointFlag (int point_index, bool bHidden)
bool | PointIsHidden (int point_index) const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Public Attributes

ON_3dPointArray | m_P
ON_SimpleArray< ON_3dVector > | m_N
ON_SimpleArray< ON_Color > | m_C
ON_SimpleArray< bool > | m_H
int | m_hidden_count
ON_Plane | m_plane
ON_BoundingBox | m_bbox
unsigned int | m_flags

## Detailed Description

Definition at line 26 of file opennurbs_pointcloud.h.

## Constructor & Destructor Documentation

ON_PointCloud::ON_PointCloud | ( |  | ) |

ON_PointCloud::ON_PointCloud | ( | int |  | ) |

ON_PointCloud::ON_PointCloud | ( | const ON_PointCloud & |  | ) |

ON_PointCloud::~ON_PointCloud | ( |  | ) |

## Member Function Documentation

void ON_PointCloud::AppendPoint | ( | const ON_3dPoint & |  | ) |

void ON_PointCloud::Destroy | ( |  | ) |

void ON_PointCloud::DestroyHiddenPointArray | ( |  | ) |

int ON_PointCloud::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

void ON_PointCloud::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

void ON_PointCloud::EmergencyDestroy | ( |  | ) |

ON_BOOL32 ON_PointCloud::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

bool ON_PointCloud::GetClosestPoint | ( | ON_3dPoint | P,
|  | int * | closest_point_index,
|  | double | maximum_distance = `0.0`
| ) |  | const

bool ON_PointCloud::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

bool ON_PointCloud::HasPlane | ( |  | ) | const

bool ON_PointCloud::HasPointColors | ( |  | ) | const

bool ON_PointCloud::HasPointNormals | ( |  | ) | const

double ON_PointCloud::Height | ( | int |  | ) |

const bool* ON_PointCloud::HiddenPointArray | ( |  | ) | const

int ON_PointCloud::HiddenPointCount | ( |  | ) | const

void ON_PointCloud::InvalidateBoundingBox | ( |  | ) |

bool ON_PointCloud::IsDeformable | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

bool ON_PointCloud::IsOrdered | ( |  | ) | const

ON_BOOL32 ON_PointCloud::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

bool ON_PointCloud::MakeDeformable | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

ON::object_type ON_PointCloud::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

ON_PointCloud& ON_PointCloud::operator= | ( | const ON_PointCloud & |  | ) |

ON_3dPoint& ON_PointCloud::operator[] | ( | int |  | ) |

const ON_3dPoint& ON_PointCloud::operator[] | ( | int |  | ) | const

const ON_Plane& ON_PointCloud::Plane | ( |  | ) |

ON_3dPoint ON_PointCloud::Point | ( | ON_COMPONENT_INDEX | ci | ) | const

int ON_PointCloud::PointCount | ( |  | ) | const

bool ON_PointCloud::PointIsHidden | ( | int | point_index | ) | const

ON_BOOL32 ON_PointCloud::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

void ON_PointCloud::SetHiddenPointFlag | ( | int | point_index,
|  | bool | bHidden
| ) |  |

void ON_PointCloud::SetOrdered | ( | bool | bOrdered | ) |

void ON_PointCloud::SetPlane | ( | const ON_Plane & |  | ) |

ON_BOOL32 ON_PointCloud::SwapCoordinates | ( | int | ,
|  | int |
| ) |  |

virtual

Reimplemented from ON_Geometry.

ON_BOOL32 ON_PointCloud::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

ON_BOOL32 ON_PointCloud::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

ON_BoundingBox ON_PointCloud::m_bbox

Definition at line 233 of file opennurbs_pointcloud.h.

ON_SimpleArray<ON_Color> ON_PointCloud::m_C

Definition at line 221 of file opennurbs_pointcloud.h.

unsigned int ON_PointCloud::m_flags

Definition at line 234 of file opennurbs_pointcloud.h.

ON_SimpleArray<bool> ON_PointCloud::m_H

Definition at line 229 of file opennurbs_pointcloud.h.

int ON_PointCloud::m_hidden_count

Definition at line 230 of file opennurbs_pointcloud.h.

ON_SimpleArray<ON_3dVector> ON_PointCloud::m_N

Definition at line 214 of file opennurbs_pointcloud.h.

ON_3dPointArray ON_PointCloud::m_P

Definition at line 207 of file opennurbs_pointcloud.h.

ON_Plane ON_PointCloud::m_plane

Definition at line 232 of file opennurbs_pointcloud.h.

The documentation for this class was generated from the following file:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_pointcloud.h